var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "ps-config.log";
lWarn = new Logger(LOGFILE_NAME);
//lInfo = new Logger(LOGFILE_NAME);

var propertyPathForTE='/scripts/system-addon-timed-events/';
var propertyPathForPS='/scripts/system-addon-presence-simulator/';
var propertyPathForSR='/scripts/system-addon-scene-responder/';

var Utf8 = {
        
        // public method for url encoding
        encode : function (string) {
            string = string.replace(/\r\n/g,"\n");
            var utftext = "";
     
            for (var n = 0; n < string.length; n++) {
     
                var c = string.charCodeAt(n);
     
                if (c < 128) {
                    utftext += String.fromCharCode(c);
                }
                else if((c > 127) && (c < 2048)) {
                    utftext += String.fromCharCode((c >> 6) | 192);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
                else {
                    utftext += String.fromCharCode((c >> 12) | 224);
                    utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
     
            }
     
            return utftext;
        },
     
        // public method for url decoding
        decode : function (utftext) {
            var string = "";
            var i = 0;
            var c = c1 = c2 = 0;
     
            while ( i < utftext.length ) {
     
                c = utftext.charCodeAt(i);
     
                if (c < 128) {
                    string += String.fromCharCode(c);
                    i++;
                }
                else if((c > 191) && (c < 224)) {
                    c2 = utftext.charCodeAt(i+1);
                    string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                    i += 2;
                }
                else {
                    c2 = utftext.charCodeAt(i+1);
                    c3 = utftext.charCodeAt(i+2);
                    string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                    i += 3;
                }
     
            }
     
            return string;
        }
     
    }

// ---------------------------  TE Zeug
function setSimulationForTE(id,fOn){
    if (fOn)
        Property.setProperty(propertyPathForTE+'entries/' + id + '/conditions/states/holiday', 'on');
    else
        Property.setProperty(propertyPathForTE+'entries/' + id + '/conditions/states/holiday', 'off');
}

function getSimulationForTE(id) {
    var aTimedEventsNode = Property.getNode(propertyPathForTE+'entries/' + id + '/conditions/states/holiday');
    if (aTimedEventsNode!=null)
        return (aTimedEventsNode.getValue()=="on");
    return false;
}

function getSimValueForID(id) {
    var aEventsNode = Property.getNode(propertyPathForPS+'entries/' + id);
    if (aEventsNode!=null)
        return true;
    return false;
}

function setSimValueForID(id,fOn) {
    if (fOn) {
        Property.setProperty(propertyPathForPS+'entries/' + id, id);
        Property.setFlag(propertyPathForPS+'entries/' + id, 'ARCHIVE', true);
    } else {
        Property.getNode(propertyPathForPS+'entries/').removeChild(id);
    }
}

function syncPSWithTE() {
    // TE durchgehen, und deren State /condition/state/holiday hier lokal kopieren und speichern 
    Property.getNode(propertyPathForPS).removeChild('entries');
    var oTEBaseNew = Property.getNode(propertyPathForTE+'entries');
    if (oTEBaseNew==null)
        return;
    var aTEEntriesArray = oTEBaseNew.getChildren(); 
    for (var iIndex=0; iIndex<aTEEntriesArray.length; iIndex++) {
        var id=aTEEntriesArray.getChild('id').getValue();
        
        var fIsActivated=getSimulationForTE(id);
        if (fIsActivated)
            lWarn.logln("TE Node " + id + " is a simulated Node");
        else
            lWarn.logln("TE Node " + id + " is not a simulated Node");
        setSimValueForID(id,fIsActivated)
    }
    Property.store();
}

function syncTEWithPS() {
    Property.load();
    // PS durchgehen und dortige Eintrge nutzen um TE zu ndern
    var oTEBaseNew = Property.getNode(propertyPathForTE+'entries');
    if (oTEBaseNew==null) {
        lWarn.logln("no TE Nodes");
        return;
    }
    var aTEEntriesArray = oTEBaseNew.getChildren(); 
    lInfo.logln("configure " + aTEEntriesArray.length + " TE Nodes");
    for (var iIndex=0; iIndex<aTEEntriesArray.length; iIndex++) {
        var id=aTEEntriesArray[iIndex].getChild('id').getValue();
        var fShouldBeActivated=getSimValueForID(id);
        if (fShouldBeActivated)
            lWarn.logln("TE Node " + id + " should be a simulated");
        else
            lWarn.logln("TE Node " + id + " should not be a simulated");
        setSimulationForTE(id,fShouldBeActivated);            
    }
}

function syncSRwithPS() {
     
}